<ion-header>
  <ion-toolbar color="primary">
    <ion-buttons slot="start">
      <ion-back-button></ion-back-button>
    </ion-buttons>
    <ion-title>
      Compliant Report Details
    </ion-title>
    <ion-buttons slot="end" style="font-size: 1.8rem;" routerDirection="root" routerLink="/home">
      <ion-icon name="home"></ion-icon>
    </ion-buttons>
  </ion-toolbar>
</ion-header>
<ion-content>
  <mat-vertical-stepper [linear]="isLinear" #stepper>
    <mat-step [stepControl]="detailFormGroup">
      <form [formGroup]="detailFormGroup" class="example-form">
        <ng-template matStepLabel>Details</ng-template>
        <!-- complaint_no -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Complaint No</mat-label>
          <input matInput formControlName="complaintNoCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.complaintNoCtrlErrorMessage">
              <div *ngIf="detailFormGroup.get('complaintNoCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- complaint_date -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Complaint Date</mat-label>
          <input matInput formControlName="complaintDateCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.complaintDateCtrlErrorMessage">
              <div *ngIf="detailFormGroup.get('complaintNoCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Document Type -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Document Type</mat-label>
          <mat-select formControlName="documentTypeCtrl" [(ngModel)]="docType"
            (selectionChange)="docTypeSelectedChange(docTypeSelected)">
            <mat-option *ngFor="let doc of existingComplaint.doctype" [value]="doc">
              {{doc.name}}
            </mat-option>
          </mat-select>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.documentType">
              <div *ngIf="detailFormGroup.get('documentTypeCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Name of Complainer -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Name of Complainer</mat-label>
          <input matInput formControlName="nameOfComplainerCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.nameCtrlErrorMessage">
              <div *ngIf="detailFormGroup.get('nameOfComplainerCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Designation of Complainer -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Designation of Complainer</mat-label>
          <mat-select [(ngModel)]="designationOfComplainerType" formControlName="desigOfComplainerCtrl"
            (selectionChange)="designationOfComplainerChange(designationOfComplainerSelected)">
            <mat-option *ngFor="let designationObject of designationOfComplainerList" [value]="designationObject">
              {{designationObject.name}}
            </mat-option>
          </mat-select>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.designation_of_complainer_mss">
              <div *ngIf="detailFormGroup.get('desigOfComplainerCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Contact No -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Contact No</mat-label>
          <input matInput formControlName="mobilenoCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.mobileno">
              <div *ngIf="detailFormGroup.get('mobilenoCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Email ID -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Email ID</mat-label>
          <input matInput formControlName="emailIDCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.email">
              <div *ngIf="detailFormGroup.get('emailIDCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Event Date -->
        <mat-form-field class="example-full-width">
          <mat-label>Event Date</mat-label>
          <input matInput [disabled]='true' formControlName="eventDateIDCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.eventDateIDCtrlErrorMessage">
              <div *ngIf="detailFormGroup.get('emailIDCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Complaint Description -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Complaint Description</mat-label>
          <textarea matInput formControlName="complaintDescriptionCtrl"></textarea>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.complaintDescription">
              <div
                *ngIf="detailFormGroup.get('complaintDescriptionCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <div>
          <button mat-button matStepperNext (click)="matDetailSettper(detailFormGroup)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Product Compliant Tab-->
    <mat-step [stepControl]="productCompliantFormGroup" *ngIf="isProductCompliantTab">
      <form [formGroup]="productCompliantFormGroup" class="example-form">
        <ng-template matStepLabel>Product Compliant</ng-template>
        <!-- Lot No -->
        <mat-form-field class="example-full-width">
          <mat-label>Lot No.</mat-label>
          <input matInput formControlName="lotNoCtrl">
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperProductCompliant($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Consumables Tab  -->
    <mat-step [stepControl]="consumablesFormGroup" *ngIf="isConsumablesTab">
      <form [formGroup]="consumablesFormGroup" class="example-form">
        <ng-template matStepLabel>Consumables</ng-template>
        <!-- Lot No -->
        <mat-form-field class="example-full-width">
          <mat-label>Lot No.</mat-label>
          <input matInput formControlName="lotNoConsumablesCtrl">
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperConsumables($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Equiment Tab-->
    <mat-step [stepControl]="equimentFormGroup" *ngIf="isEquimentTab">
      <form [formGroup]="equimentFormGroup" class="example-form">
        <ng-template matStepLabel>Equiment</ng-template>
        <!-- Serial No -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Serial No.</mat-label>
          <input matInput formControlName="serialNoCtrl" [(ngModel)]="existingComplaint.serialno" (change)='onCheckInstallationBase()'>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.serialNo">
              <div *ngIf="equimentFormGroup.get('serialNoCtrl').hasError(validation.type) && equimentStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Sr. No. of Equipment -->
        <!-- <mat-form-field class="example-full-width">
          <mat-label>Sr. No. of Equipment</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.srnoequipment"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field> -->
        <!-- Contract Type -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Contract Type</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="contracttypeSelected" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Invoice No -->
        <mat-form-field class="example-full-width">
          <mat-label>Invoice No.</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.invoiceno"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Invoice Date -->
        <div class="example-full-width bottom-border">
          <ion-label style="color: darkgray;">Invoice Date</ion-label>
          <section class="cus">
           <!-- <ion-datetime  [disabled]='true' style="--padding-start:0px" displayFormat="DD-MM-YYYY" [ngModelOptions]="{standalone: true}" [(ngModel)]="existingComplaint.invoicedate"  [max]="maxDate | date:'yyyy-MM-dd'">
          </ion-datetime>
          <ion-icon name="calendar"></ion-icon>  -->
          <ion-item>
            <ion-input placeholder="Select Date" [value]="dateinvoice"></ion-input>
            <ion-button fill="clear" id="open-date-input-1">
              <ion-icon icon="calendar"></ion-icon>
            </ion-button>
            <ion-popover class="dateTimePopover" trigger="open-date-input-1" show-backdrop="false">
              <ng-template>
                <ion-datetime
                  #popoverDatetime2
                  [ngModelOptions]="{standalone: true}" [(ngModel)]="existingComplaint.invoicedate"  
                  [max]="maxDate | date:'yyyy-MM-dd'"
                  presentation="date"
                  showDefaultButtons="true"
                  (ionChange)="dateinvoice = formatDate(popoverDatetime2.value)"
                ></ion-datetime>
              </ng-template>
            </ion-popover>
          </ion-item>
        </section>
        </div>
        
      
        <!-- Error Code -->
        <!-- <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Error Code</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.errorcode[0].name"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field> -->

        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Error Code</mat-label>
          <mat-select [(ngModel)]="errorCodeSelected" formControlName="errorCode"
            (selectionChange)="errorCodeSelectedSelectedChange(errorCodeSelected)">
            <mat-option *ngFor="let errorCode of errorCodeList" [value]="errorCode">
              {{errorCode.name}}
            </mat-option>
          </mat-select>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.errorCodeCtrlErrorMessage">
              <div *ngIf="equimentFormGroup.get('errorCode').hasError(validation.type) && firstStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>

        <!-- Dealer Name -->
        <mat-form-field class="example-full-width">
          <mat-label>Dealer Name</mat-label>
          <input matInput formControlName="dealerNameCtrl" [(ngModel)]="existingComplaint.dealername">
        </mat-form-field>
        <!-- New Dealer Name -->
        <mat-form-field class="example-full-width">
          <mat-label>New Dealer Name</mat-label>
          <mat-select [(ngModel)]="dealerName" formControlName="newDealerNameCtrl"
            (selectionChange)="newDealerNameChange(dealerName)" >
            <mat-option *ngFor="let dealer of dealerList" [value]="dealer">
              {{dealer.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <!-- Sales Representative -->
        <mat-form-field class="example-full-width">
          <mat-label>Sales Representative</mat-label>
          <mat-select formControlName="salesRepresentativeCtrl" [(ngModel)]="salesRepresentativeSelected"
            (selectionChange)="salesRepresentativeChange(salesRepresentative)">
            <mat-option *ngFor="let salesRepresentative of salesRepresentativeList" [value]="salesRepresentative">
              {{salesRepresentative.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <!-- Installation Date -->
        <div class="example-full-width bottom-border">
          <ion-label style="color: darkgray;">Installation Date</ion-label>
          <section class="cus">
           <!-- <ion-datetime  style="--padding-start:0px" displayFormat="DD-MM-YYYY" [(ngModel)]="existingComplaint.installationdate" formControlName="installationDateCtrl" [max]="maxDate | date:'yyyy-MM-dd'">
          </ion-datetime>
          <ion-icon name="calendar"></ion-icon>  -->
          <ion-item>
            <ion-input placeholder="Select Date" [value]="dateinstall"></ion-input>
            <ion-button fill="clear" id="open-date-input-2">
              <ion-icon icon="calendar"></ion-icon>
            </ion-button>
            <ion-popover class="dateTimePopover" trigger="open-date-input-2" show-backdrop="false">
              <ng-template>
                <ion-datetime
                  #popoverDatetime2
                  [(ngModel)]="existingComplaint.installationdate" formControlName="installationDateCtrl" 
                  [max]="maxDate | date:'yyyy-MM-dd'"
                  presentation="date"
                  showDefaultButtons="true"
                  (ionChange)="dateinvoice = formatDate1(popoverDatetime2.value)"
                ></ion-datetime>
              </ng-template>
            </ion-popover>
          </ion-item>
        </section>
        </div>     
        <!-- <mat-form-field class="example-full-width">
          <mat-label>Installation Date</mat-label>
          <input matInput formControlName="installationDateCtrl" [(ngModel)]="existingComplaint.installationdate">
        </mat-form-field> -->
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperEquiment($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- SKU Details Tab-->
    <mat-step [stepControl]="skuDetailsFormGroup">
      <form [formGroup]="skuDetailsFormGroup" class="example-form">
        <ng-template matStepLabel>SKU Details</ng-template>
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">SKU Code</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.skucode" formControlName="skuCodeCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.skuCodeCtrlErrorMessage">
              <div *ngIf="skuDetailsFormGroup.get('skuCodeCtrl').hasError(validation.type) && skuDetailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- SKU Name / Description -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">SKU Name / Description</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.skuname" formControlName="skuNameCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.SKUNameCtrlErrorMessage">
              <div *ngIf="skuDetailsFormGroup.get('skuNameCtrl').hasError(validation.type) && skuDetailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Brand Name -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Brand Name</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.brandname" formControlName="brandNameCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.brandNameCtrlErrorMessage">
              <div *ngIf="skuDetailsFormGroup.get('brandNameCtrl').hasError(validation.type) && skuDetailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Product to be returned -->
        <mat-form-field class="example-full-width">
          <mat-label>Product to be returned</mat-label>
          <mat-select [disabled]='true' [(ngModel)]="productToBeReturn" [ngModelOptions]="{standalone: true}">
            <mat-option value="Yes">Yes</mat-option>
            <mat-option value="No">No</mat-option>
          </mat-select>
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperSKUDetails($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Customer Detail Tab -->
    <mat-step [stepControl]="customerDetailFormGroup">
      <form [formGroup]="customerDetailFormGroup" class="example-form">
        <ng-template matStepLabel>Customer Detail</ng-template>
        <!-- Customer Name -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Customer Name</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="existingComplaint.custname"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Customer Address 1 -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Customer Address 1</mat-label>
          <input matInput formControlName="customerAddress1Ctrl" [(ngModel)]="existingComplaint.add1">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.customerAddress1">
              <div
                *ngIf="customerDetailFormGroup.get('customerAddress1Ctrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Customer Address 2 -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Address 2</mat-label>
          <input matInput formControlName="customerAddress2Ctrl" [(ngModel)]="existingComplaint.add2">
        </mat-form-field>
        <!-- Customer Address 3 -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Address 3</mat-label>
          <input matInput formControlName="customerAddress3Ctrl" [(ngModel)]="existingComplaint.add3">
        </mat-form-field>
        <!-- Pin Code -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Pin Code</mat-label>
          <input type="number" matInput formControlName="pinCodeCtrl" (change)='onChangePinCode()'>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.pinCode">
              <div
                *ngIf="customerDetailFormGroup.get('pinCodeCtrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Area -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Area</mat-label>
          <!-- <input matInput formControlName="areaCtrl"> -->
          <mat-select [(ngModel)]="areaType" formControlName="areaCtrl" (selectionChange)="onAreaSelectedChange()">
            <mat-option *ngFor="let areaObject of areaList" [value]="areaObject">
              {{areaObject.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <!-- City -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">City</mat-label>
          <input matInput formControlName="city" [(ngModel)]="city">
        </mat-form-field>
        <!-- State -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">State</mat-label>
          <input matInput formControlName="state" [(ngModel)]="state">
        </mat-form-field>
        <!-- Country -->
        <mat-form-field class="example-full-width">
          <mat-label class="asterisk_input">Country</mat-label>
          <input matInput formControlName="country" [(ngModel)]="country">
        </mat-form-field>
        <!-- Approve existingComplaint -->
        <section class="example-full-width">
          <mat-checkbox formControlName="approveComplaintChkCtrl" [color]="color" [(ngModel)]="isChecked"
            (change)="approveComplaintCheckbox($event.checked)" [disabled]="!approveCheckBoxEditable" class="example-margin">Approve Complaint</mat-checkbox>
        </section>
        <!-- Service Vendor -->
        <mat-form-field class="example-full-width" *ngIf="isServiceVender">
          <mat-label>Service Vendor</mat-label>
          <mat-select formControlName="serviceVendorCtrl" >
            <mat-option *ngFor="let vender of venderList" [value]="vender">
              {{vender.name}}
            </mat-option>
          </mat-select>
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.serviceVendorMessage">
              <div
                *ngIf="customerDetailFormGroup.get('serviceVendorCtrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
        </div>
        <div>
          <ion-row>
            <ion-col no-padding>
              <ion-button size="default" [disabled]="!customerDetailFormGroup.valid" expand="block" color="primary"
                (click)="submit($event)">Assign Vendor
              </ion-button>
            </ion-col>
          </ion-row>
        </div>
      </form>
    </mat-step>
  </mat-vertical-stepper>
</ion-content>